' --- Jiri Zima / notebookblog.cz ---
' verze bez zvuku -> jde spustit i v orezanem prostredi QBasic

DIM txt(1 TO 22) AS STRING * 60

		 '------------------------------------------------------------'
		 '         |         :         |         :         |          '
txt(1) = "             Preju hodne stesti v dalsim roce!              "
txt(2) = "      Snad Vas v nem nebude provazet mnoho starosti...      "
txt(3) = "  ... a najdete si cas na oddychove cteni o noteboocich ;)  "
txt(4) = "  Konec sveta neprisel, a tak jsem se snazil vymyslet,...   "
txt(5) = "   ... jak bych mohl neuzitecne zabit par poslednich dni.   "
txt(6) = "  Psani PFka ve 25 let starem programovacim prostredi...    "
txt(7) = "... Quick Basic 4.5 bylo to nejmene uzitecne, co me napadlo."
txt(8) = "Specifika jazyka jsem se naucil z vyborne napovedy programu."
txt(9) = "         Zbytek jsem odkoukal z tutorialu na netu.          "
txt(10) = " Obrazek s krajinou se vykresluje v 640x480 se 16 barvami.  "
txt(11) = "  To je ostatne maximum, co umi graficka karta VGA (1987).  "
txt(12) = "   Veskere animace jsou tvorene neustalym menenim palety.   "
txt(13) = " Zvuk obstarava projekt FMEngine (obsluha zvukovky AdLib).  "
txt(14) = "             Vypujcil jsem si z nej i hudbu.                "
txt(15) = "Cele by to melo s prehledem bezet na PC AT se 6-MHz 286,... "
txt(16) = "... 512kB RAM, grafikou VGA a volitelnou zvukovkou AdLib/SB."
txt(17) = "   Obrazek jsem nakreslil na muzejnim grafickem tabletu.    "
txt(18) = "Prevod na 16 barev byl trochu orisek, ale vysledek me tesi. "
txt(19) = "12 barev je pro statickou grafiku, 3 pro vodu a 1 pro text. "
txt(20) = "                 Snad se vam to libilo! :)                  "
txt(21) = "                - swarm, notebookblog.cz / swarm@swarm.cz   "
txt(22) = "                                                            "

TYPE BMPHeaderType
		id AS STRING * 2      'Should be "BM"
		size AS LONG          'Size of the data
		rr1 AS INTEGER        '
		rr2 AS INTEGER        '
		offset AS LONG        'Position of start of pixel data
		horz AS LONG          '
		wid AS LONG           'Image width
		hei AS LONG           'Image height
		planes AS INTEGER     '
		bpp AS INTEGER        'Should read 8 for a 256 colour image
		pakbyte AS LONG       '
		imagebytes AS LONG    'Width*Height
		xres AS LONG          '
		yres AS LONG          '
		colch AS LONG         '
		ic AS LONG            '
		pal AS STRING * 64    'Stored as: Blue, Green, Red, 0;
END TYPE

DIM bmpheader AS BMPHeaderType

OPEN "image.pal" FOR BINARY AS #1

  GET #1, , bmpheader

SCREEN 12                       ' 640x480 16 barev

' nastavi paletu z headeru BMP
a$ = bmpheader.pal                  ' 1024 character string

DIM paletteI(0 TO 15, 1 TO 3)  AS INTEGER ' (index; r, g, b)
FOR i% = 1 TO 64 STEP 4
	paletteI((i% - 1) \ 4, 1) = ASC(MID$(a$, i%, 1)) \ 4  'blue
	paletteI((i% - 1) \ 4, 2) = ASC(MID$(a$, i% + 1, 1)) \ 4  'green
	paletteI((i% - 1) \ 4, 3) = ASC(MID$(a$, i% + 2, 1)) \ 4  'red
NEXT i%
 
FOR i% = 1 TO 3
	paletteI(15, i%) = paletteI(0, i%)
NEXT i%

' uzavrit BMP soubor (ted uz jen oddelenou hlavicku)
CLOSE #1

CLS


' nastavi vsechny barvy na cernou
OUT &H3C8, 0                        ' Start writing from Colour 0
FOR i% = 0 TO 15
	OUT &H3C9, 0                   ' Set the colour.
	OUT &H3C9, 0
	OUT &H3C9, 0   ' kazde 3 OUT nebo IMP prehodi na dalsi barvu
NEXT


REM $DYNAMIC        ' pokud nejsou dynamic, musi se dohromady vejit do 64k
DIM loaded(16004)

LINE (0, 0)-(640, 59), 0, BF

DEF SEG = VARSEG(loaded(0))
BLOAD "screenh.dat", VARTR(loaded(0))   ' prvnich 64k obrazku
DEF SEG
PUT (0, 60), loaded, PSET

DEF SEG = VARSEG(loaded(0))
BLOAD "screenl.dat", VARTR(loaded(0))   ' druhych 64k obrazku
DEF SEG
PUT (0, 260), loaded, PSET

LINE (0, 460)-(640, 480), 13, BF

' fade in

Time! = TIMER
fadetime! = 0
fade! = .1

DO
	Time! = TIMER
	IF Time! - fadetime! > .01 THEN
	fadetime! = Time!

	OUT &H3C8, 0
	FOR i% = 0 TO 15
		FOR j% = 3 TO 1 STEP -1
			OUT &H3C9, paletteI(i%, j%) * fade!
		NEXT j%
	NEXT i%

	fade! = fade! + .1
	IF fade! > 1 THEN EXIT DO
	END IF
LOOP

' ulozeni barev vodopadu indexy: 12-11-7

DIM watercol%(0 TO 3, 1 TO 3) ' channel, color
watercol%(0, 1) = 12
watercol%(0, 2) = 11
watercol%(0, 3) = 7

FOR colorI% = 1 TO 3
	OUT &H3C7, watercol%(0, colorI%)
	' PRINT "    ", watercol%(0, colorI%);
	FOR chanI% = 1 TO 3
		watercol%(chanI%, colorI%) = INP(&H3C9)
		' PRINT watercol%(chanI%, colorI%);
	NEXT chanI%

NEXT colorI%

waterstate = 2
waterref! = TIMER

textlock% = 0
textfade% = 0
textstep% = 2

textref! = 0
textlockref! = 0

COLOR 15: LOCATE 3, 10
txtcur% = 1
PRINT txt(txtcur%)

DO
	Time! = TIMER
   
	' --- Prekresleni vody ---

	IF Time! - waterref! > .2 THEN
		'PRINT Time! - waterref!
		waterref! = Time!
		i% = waterstate
		FOR j% = 1 TO 3
			OUT &H3C8, watercol%(0, i%)
			FOR chanI% = 1 TO 3
				OUT &H3C9, watercol%(chanI%, j%)
			NEXT chanI%
			i% = i% + 1
			IF i% = 4 THEN i% = 1
		NEXT j%
		waterstate = waterstate + 1
		IF waterstate = 4 THEN waterstate = 1
	END IF

	' --- Zastaveni textu ---
	IF Time! - textlockref! > 3 AND textlock% = 1 THEN
		textlock% = 0
	END IF
	IF Time! - textlockref! > 1 AND textlock% = 2 THEN
		textlock% = 0
		COLOR 15: LOCATE 3, 10
		PRINT txt(txtcur%)

	END IF


	' --- Prekresleni textu ---
	IF Time! - textref! > .02 AND textlock% = 0 THEN
		textref! = Time!
	   
		OUT &H3C8, 15
		OUT &H3C9, paletteI(15, 1) - 2 ' + textfade% / 2  'r
		OUT &H3C9, paletteI(15, 2) - 2 + textfade% / 2'g
		OUT &H3C9, paletteI(15, 3) - 2 + textfade% / 1.5'b
	   
		textfade% = textfade% + textstep%
		IF (paletteI(15, 1) + textfade%) > 50 THEN
			textfade% = 50 - paletteI(15, 1)
			textlock% = 1
			textstep% = -textstep%
			textlockref! = TIMER
		END IF
		IF textfade% < 0 AND textstep% < 0 THEN
			textfade% = 0
			textlock% = 2
			textstep% = -textstep%
			txtcur% = txtcur% + 1
			IF txtcur% > 22 THEN txtcur% = 1
		   
			COLOR 15: LOCATE 3, 10
			PRINT txt(22)

			textlockref! = TIMER
		END IF
	   
	END IF

	IF INKEY$ <> "" THEN EXIT DO  ' Stisk klavesy
LOOP

' fade out

fade! = .9

DO
	Time! = TIMER
	IF Time! - fadetime! > .01 THEN
	fadetime! = Time!

	OUT &H3C8, 0
	FOR i% = 0 TO 15
		FOR j% = 3 TO 1 STEP -1
			OUT &H3C9, paletteI(i%, j%) * fade!
		NEXT j%
	NEXT i%

	fade! = fade! - .05
	IF fade! < .1 THEN EXIT DO
	END IF
LOOP
CLS

SCREEN 0

END

